Public Class fmMain
    Private WithEvents wclSerialMonitor As wclSerialMonitor
    Private WithEvents FPowerMonitor As wclPowerEventsMonitor
    Private Running As Boolean = False

    Private Sub fmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        wclSerialMonitor = New wclSerialMonitor()

        FPowerMonitor = New wclPowerEventsMonitor()
        FPowerMonitor.Open()
    End Sub

    Private Sub btClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btClear.Click
        lbEvents.Items.Clear()
    End Sub

    Private Sub wclSerialMonitor_OnInserted(ByVal Sender As Object, ByVal Device As wclSerial.wclSerialDevice) Handles wclSerialMonitor.OnInserted
        lbEvents.Items.Add("Device inserted:")
        lbEvents.Items.Add("Friendly name: " + Device.FriendlyName)
        lbEvents.Items.Add("  Modem: " + Device.IsModem.ToString())
        lbEvents.Items.Add("  DeviceName: " + Device.DeviceName)
    End Sub

    Private Sub wclSerialMonitor_OnRemoved(ByVal Sender As Object, ByVal Device As wclSerial.wclSerialDevice) Handles wclSerialMonitor.OnRemoved
        lbEvents.Items.Add("Device removed:")
        lbEvents.Items.Add("Friendly name: " + Device.FriendlyName)
        lbEvents.Items.Add("  Modem: " + Device.IsModem.ToString())
        lbEvents.Items.Add("  DeviceName: " + Device.DeviceName)
    End Sub

    Private Sub fmMain_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        wclSerialMonitor.Stop()
        FPowerMonitor.Close()
    End Sub

    Private Sub btEnum_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btEnum.Click
        lvDevices.Items.Clear()

        Dim Devices() As wclSerialDevice = Nothing
        Dim Res As Int32 = wclSerialMonitor.EnumDevices(Devices)
        lbEvents.Items.Add("Enumerate serial devices: 0x" + Res.ToString("X8"))

        If Res = wclErrors.WCL_E_SUCCESS Then
            If Devices IsNot Nothing Then
                Dim i As Integer
                For i = 0 To Devices.Length - 1
                    Dim Item As ListViewItem = lvDevices.Items.Add(Devices(i).FriendlyName)
                    Item.SubItems.Add(Devices(i).IsModem.ToString())
                    Item.SubItems.Add(Devices(i).DeviceName)
                Next i
            End If
        End If
    End Sub

    Private Sub btStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btStart.Click
        Dim Res As Int32 = wclSerialMonitor.Start()
        lbEvents.Items.Add("Monitoring started: 0x" + Res.ToString("X8"))
    End Sub

    Private Sub btStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btStop.Click
        Dim Res As Int32 = wclSerialMonitor.Stop()
        lbEvents.Items.Add("Monitoring stopped: 0x" + Res.ToString("X8"))
    End Sub

    Private Sub FPowerMonitor_OnPowerStateChanged(Sender As Object, State As wclCommon.wclPowerState) Handles FPowerMonitor.OnPowerStateChanged
        Select State
            Case wclPowerState.psResumeAutomatic
                If Running Then
                    Running = False
                    wclSerialMonitor.Start()
                End If
                lbEvents.Items.Add("Power changed: psResumeAutomatic")

            Case wclPowerState.psResume
                lbEvents.Items.Add("Power changed: psResume")

            Case wclPowerState.psSuspend
                If wclSerialMonitor.Monitoring Then
                    Running = True
                    wclSerialMonitor.Stop()
                End If
                lbEvents.Items.Add("Power changed: psSuspend")

            Case wclPowerState.psUnknown
                lbEvents.Items.Add("Power changed: psUnknown")
        End Select
    End Sub
End Class
