Public Class fmMain
    Private WithEvents Monitor As wclUsbMonitor

    Private Sub fmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Monitor = New wclUsbMonitor()
    End Sub

    Private Sub btEnum_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btEnum.Click
        lvDevices.Items.Clear()

        Dim Devices As wclUsbDevice() = Nothing
        Dim Res As Integer = Monitor.EnumDevices(Devices)
        If Res <> wclErrors.WCL_E_SUCCESS Then
            MessageBox.Show("Unumeration failed: 0x" + Res.ToString("X8"))
        Else
            If Devices IsNot Nothing Then
                For Each Device As wclUsbDevice In Devices
                    Dim Item As ListViewItem = lvDevices.Items.Add(Device.FriendlyName)
                    Item.SubItems.Add(Device.HardwareId)
                    Item.SubItems.Add(Device.VendorId.ToString("X4"))
                    Item.SubItems.Add(Device.ProductId.ToString("X4"))
                    Item.SubItems.Add(Device.Revision.ToString("X4"))
                    Item.SubItems.Add(Device.Manufacturer)
                    Item.SubItems.Add(Device.Instance)
                    Item.SubItems.Add(Device.ClassGuid.ToString())
                    Item.SubItems.Add(Device.Enabled.ToString())
                Next Device
            End If
        End If
    End Sub

    Private Sub Monitor_OnInserted(ByVal Sender As Object, ByVal Device As wclSerial.wclUsbDevice) Handles Monitor.OnInserted
        lbEvents.Items.Add("Device inserted: " + Device.Instance)
    End Sub

    Private Sub Monitor_OnRemoved(ByVal Sender As Object, ByVal Device As wclSerial.wclUsbDevice) Handles Monitor.OnRemoved
        lbEvents.Items.Add("Device removed: " + Device.Instance)
    End Sub

    Private Sub fmMain_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        Monitor.Stop()
    End Sub

    Private Sub btClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btClear.Click
        lbEvents.Items.Clear()
    End Sub

    Private Sub btStartMonitoring_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btStartMonitoring.Click
        Dim Res As Int32 = Monitor.Start()
        If Res <> wclErrors.WCL_E_SUCCESS Then
            MessageBox.Show("Start monitoring failed: 0x" + Res.ToString("X8"))
        Else
            lbEvents.Items.Add("Monitoring started")
        End If
    End Sub

    Private Sub btStopMonitoring_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btStopMonitoring.Click
        Dim Res As Int32 = Monitor.Stop()
        If Res <> wclErrors.WCL_E_SUCCESS Then
            MessageBox.Show("Stop monitoring failed: 0x" + Res.ToString("X8"))
        Else
            lbEvents.Items.Add("Monitoring stopped")
        End If
    End Sub

    Private Sub btEnable_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btEnable.Click
        If lvDevices.SelectedItems.Count = 0 Then
            MessageBox.Show("Select device")
        Else
            Dim Res As Int32 = Monitor.Enable(lvDevices.SelectedItems(0).SubItems(3).Text)
            If Res <> wclErrors.WCL_E_SUCCESS Then
                MessageBox.Show("Failed to enable device: 0x" + Res.ToString("X8"))
            End If
        End If
    End Sub

    Private Sub btDisable_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btDisable.Click
        If lvDevices.SelectedItems.Count = 0 Then
            MessageBox.Show("Select device")
        Else
            Dim Res As Int32 = Monitor.Disable(lvDevices.SelectedItems(0).SubItems(3).Text)
            If Res <> wclErrors.WCL_E_SUCCESS Then
                MessageBox.Show("Failed to disable device: 0x" + Res.ToString("X8"))
            End If
        End If
    End Sub
End Class
